"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = ModalView;
var React = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _native = require("@react-navigation/native");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ModalView(_ref) {
  let {
    state,
    navigation,
    descriptors
  } = _ref;
  return /*#__PURE__*/React.createElement(_native.NavigationHelpersContext.Provider, {
    value: navigation
  }, /*#__PURE__*/React.createElement(_reactNative.View, {
    style: styles.container
  }, state.routes.reduceRight((acc, route, index) => {
    const focused = index === state.index;
    const descriptor = descriptors[route.key];
    if (descriptor == null) {
      return acc;
    }
    const {
      animationType = 'slide',
      ...options
    } = descriptor.options;
    const element = /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_reactNative.View, {
      style: _reactNative.StyleSheet.absoluteFill,
      accessibilityElementsHidden: !focused,
      importantForAccessibility: focused ? 'auto' : 'no-hide-descendants'
    }, descriptor.render()), acc);
    if (index === 0) {
      return element;
    }
    const onOrientationChange = e => navigation.emit({
      type: 'orientationChange',
      target: route.key,
      data: e.nativeEvent
    });
    const onOpen = () => {
      navigation.dispatch(s => {
        if (s.routeNames.includes(route.name) && !s.routes.some(r => r.key === route.key)) {
          // If route isn't present in current state, but was closing, assume that a close animation was cancelled
          // So we need to add this route back to the state
          return _native.CommonActions.navigate(route);
        } else {
          return _native.CommonActions.reset(s);
        }
      });
    };
    const onClose = () => navigation.dispatch(s => {
      // If a route exists in state, trigger a pop
      // This will happen in when the route was closed from native side
      // e.g. When the close animation triggered from a gesture ends
      if (s.routes.some(r => r.key === route.key)) {
        return {
          ..._native.StackActions.pop(),
          source: route.key,
          target: s.key
        };
      } else {
        return _native.CommonActions.reset(s);
      }
    });
    return /*#__PURE__*/React.createElement(_reactNative.Modal, _extends({}, options, {
      animationType: animationType,
      onOrientationChange: onOrientationChange,
      onShow: onOpen,
      onDismiss: onClose,
      onRequestClose: onClose,
      visible: true
    }), element);
  }, /*#__PURE__*/React.createElement(React.Fragment, null))));
}
const styles = _reactNative.StyleSheet.create({
  container: {
    flex: 1
  }
});
//# sourceMappingURL=ModalView.js.map