function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import * as React from 'react';
import { View, Modal, StyleSheet } from 'react-native';
import { NavigationHelpersContext, StackActions, CommonActions } from '@react-navigation/native';
export default function ModalView(_ref) {
  let {
    state,
    navigation,
    descriptors
  } = _ref;
  return /*#__PURE__*/React.createElement(NavigationHelpersContext.Provider, {
    value: navigation
  }, /*#__PURE__*/React.createElement(View, {
    style: styles.container
  }, state.routes.reduceRight((acc, route, index) => {
    const focused = index === state.index;
    const descriptor = descriptors[route.key];
    if (descriptor == null) {
      return acc;
    }
    const {
      animationType = 'slide',
      ...options
    } = descriptor.options;
    const element = /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(View, {
      style: StyleSheet.absoluteFill,
      accessibilityElementsHidden: !focused,
      importantForAccessibility: focused ? 'auto' : 'no-hide-descendants'
    }, descriptor.render()), acc);
    if (index === 0) {
      return element;
    }
    const onOrientationChange = e => navigation.emit({
      type: 'orientationChange',
      target: route.key,
      data: e.nativeEvent
    });
    const onOpen = () => {
      navigation.dispatch(s => {
        if (s.routeNames.includes(route.name) && !s.routes.some(r => r.key === route.key)) {
          // If route isn't present in current state, but was closing, assume that a close animation was cancelled
          // So we need to add this route back to the state
          return CommonActions.navigate(route);
        } else {
          return CommonActions.reset(s);
        }
      });
    };
    const onClose = () => navigation.dispatch(s => {
      // If a route exists in state, trigger a pop
      // This will happen in when the route was closed from native side
      // e.g. When the close animation triggered from a gesture ends
      if (s.routes.some(r => r.key === route.key)) {
        return {
          ...StackActions.pop(),
          source: route.key,
          target: s.key
        };
      } else {
        return CommonActions.reset(s);
      }
    });
    return /*#__PURE__*/React.createElement(Modal, _extends({}, options, {
      animationType: animationType,
      onOrientationChange: onOrientationChange,
      onShow: onOpen,
      onDismiss: onClose,
      onRequestClose: onClose,
      visible: true
    }), element);
  }, /*#__PURE__*/React.createElement(React.Fragment, null))));
}
const styles = StyleSheet.create({
  container: {
    flex: 1
  }
});
//# sourceMappingURL=ModalView.js.map